from linux_router import LinuxRouter
from topologies.custom_topo import CustomTopo


class Minimal(CustomTopo):
    def build(self):
        H1 = self.addHost('h1')
        H2 = self.addHost('h2')

        S1 = self.addSwitch('s1')
        S2 = self.addSwitch('s2')

        R1 = self.addNode('r1', cls=LinuxRouter, ip="10.1.0.1/24")
        R2 = self.addNode('r2', cls=LinuxRouter, ip="10.2.0.1/24")

        self.addLink(S1, R1, intfName2="r1-eth0", params2={'ip': '10.1.0.1/24'})
        self.addLink(S2, R2, intfName2="r2-eth0", params2={'ip': '10.2.0.1/24'})

        self.addLink(R1, R2, intfName1="r1-eth1", intfName2="r2-eth1", params1={'ip': '10.112.0.11/24'}, params2={'ip': '10.112.0.21/24'})

        self.addLink(S1, H1)
        self.addLink(S1, H2)

    def get_routings(self):
        return {
            'r1': {
                "default": [
                    ("10.2.0.0/24", "10.112.0.21", "r1-eth1", 10)
                ]
            },
            'r2': {
                "default": [
                    ("10.1.0.0/24", "10.112.0.11", "r2-eth1", 10)
                ]
            }
        }

    def get_policies(self):
        return {}

    def get_tests(self):
        return {}